use core::panic::PanicInfo;

use core::alloc::{GlobalAlloc, Layout};
use core::ptr::null_mut;

pub struct StubAllocator;

unsafe impl GlobalAlloc for StubAllocator {
    unsafe fn alloc(&self, _layout: Layout) -> *mut u8 {
        null_mut()
    }
    unsafe fn dealloc(&self, _ptr: *mut u8, _layout: Layout) {}
}

#[alloc_error_handler]
fn foo(_: core::alloc::Layout) -> ! {
    panic!()
}

#[panic_handler]
fn panic(_info: &PanicInfo) -> ! {
    loop {}
}
